=== debian/changelog ===
rock-master-20.06-ruby-qtbindings (4.8.6.5-1~buster) UNRELEASED; urgency=medium

  * Package automatically built using 'apaka'

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Mon, 07 Sep 2020 00:00:01 +0200
